{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}
{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/cropper/cropper.min.css' %}">
    <style>
        .crop-preview > canvas {
            width: 100%;
            height: auto;
        }
        .django-ckeditor-widget{ width: 100% !important; }
        #cke_id_description { width: 100% !important; }
    </style>
{% endblock css %}

{% block scripts %}
    {% load static %}
    <script type="text/javascript" src="{% static 'ckeditor/ckeditor-init.js' %}"></script>
    <script type="text/javascript" src="{% static 'ckeditor/ckeditor/ckeditor.js' %}"></script>
{% endblock scripts %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page"><a href="{% url 'profile:admin_profilskpd' %}">Profil SKPD</a></li>
            <li class="breadcrumb-item active" aria-current="page">{% if edit %}Ubah{% else %}Tambah{% endif %}</li>
        </ol>
    </nav>

    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}
    
    <div class="card mb-5 shadow">
        <h5 class="card-header">{% if edit %}Ubah{% else %}Tambah{% endif %} Profil SKPD</h5>
        <div class="card-body">
            {% if edit %}
                {% if news.image %}
                    <div class="col col-md-12 mb-2 text-center" id="old-image">
                        <img class="img-responsive center-block" style="max-width: 100%; max-height: 100%;" src="{{news.image.url}}" alt="">
                        <p><small>File foto lama.</small></p>
                    </div>
                {% endif %}
            {% endif %}
            {% include 'profile/admin/profilSKPD/form.html' %}
        </div>
    </div>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %} 
    <script src="{% static 'admin/js/cropper/cropper.min.js' %}"></script>
    <script src="{% static 'admin/js/cropper/jquery-cropper.min.js' %}"></script>
    <script>
        $(document).ready(function () {
            $("#foto").val('');
            $(".modal-close").click(function () {
                $("#foto").val(null);
            });
    
            $("#foto").change(function () {
                if (this.files && this.files[0]) {
                    let reader = new FileReader();
    
                    let file = this.files[0];
                    let namafile = file.name;
                    let fileType = (file.type).toLowerCase();
                    let imageTypes = ['image/png', 'image/jpg', 'image/jpeg', 'image/gif'];
                    let videoTypes = ['video/mp4'];
    
                    if (!imageTypes.includes(fileType) && !videoTypes.includes(fileType)) {
                        Swal.fire('Peringatan !!', 'Type file tidak didukung. Hanya file gambar (PNG, JPG, JPEG, GIF) atau video (MP4) yang diizinkan.', 'warning');
                        $("#foto").val('');
                    } else if (imageTypes.includes(fileType)) {
                        // Handle image file
                        $(this).next('.custom-file-label').html(namafile);
                        reader.onload = function (e) {
                            $("#image").attr("src", e.target.result);
                            $("#modalCrop").modal("show");
                        };
                        reader.readAsDataURL(file);
                    } else if (videoTypes.includes(fileType)) {
                        // Handle video file
                        // You can add specific handling for video files here
                        console.log('Video file selected:', namafile);
                        // Clear any existing image preview or crop data
                        $("#image").removeAttr("src");
                        $(".crop-preview").html('');
                    }
                }
            });
    
            let $image = $("#image");
            let cropBoxData;
            let canvasData;
    
            $("#modalCrop").on("shown.bs.modal", function () {
                if ($image.attr("src")) {
                    $image.cropper({
                        viewMode: 1,
                        aspectRatio: 1 / 1,
                        minCropBoxWidth: 200,
                        minCropBoxHeight: 200,
                        ready: function () {
                            $image.cropper("setCanvasData", canvasData);
                            $image.cropper("setCropBoxData", cropBoxData);
                        }
                    });
                }
            }).on("hidden.bs.modal", function () {
                if ($image.attr("src")) {
                    cropBoxData = $image.cropper("getCropBoxData");
                    canvasData = $image.cropper("getCanvasData");
                    $image.cropper("destroy");
                }
            });
    
            // Enable zoom in button
            $(".js-zoom-in").click(function () {
                $image.cropper("zoom", 0.1);
            });
    
            // Enable zoom out button
            $(".js-zoom-out").click(function () {
                $image.cropper("zoom", -0.1);
            });
    
            $(".js-crop-and-upload").click(function () {
                if ($image.attr("src")) {
                    var cropData = $image.cropper("getData");
                    $("#id_x").val(cropData["x"]);
                    $("#id_y").val(cropData["y"]);
                    $("#id_height").val(cropData["height"]);
                    $("#id_width").val(cropData["width"]);
                    $("#modalCrop").modal('hide');
                    let croppedImage = $image.cropper("getCroppedCanvas");
                    $(".crop-preview").html(croppedImage);
                    $("#old-image").addClass('d-none');
                    $("#old-image").hide();
                }
            });
        });
    </script>
    
{% endblock scripts_bawah %}